Index: lib/spatial/mapbuilder/examples/catalog/ebrim2Context.xsl
===================================================================
--- lib/spatial/mapbuilder/examples/catalog/ebrim2Context.xsl	(nonexistent)
+++ lib/spatial/mapbuilder/examples/catalog/ebrim2Context.xsl	(revision 4307)
@@ -0,0 +1,130 @@
+<?xml version="1.0" encoding="ISO-8859-1"?>
+<!--
+Description: parses a EBRIM response from a Catalog Query and returns
+             an OWS Context document.
+             This stylesheet assumes the Service node follows the
+             IntrinsicObject (Layer) node.
+Author:      camerons
+Licence:     LGPL as specified in http://www.gnu.org/copyleft/lesser.html .
+
+$Id:$
+$Name:  $
+-->
+
+<xsl:stylesheet version="1.0" 
+    xmlns:wmc="http://www.opengis.net/context" 
+    xmlns:wms="http://www.opengis.net/wms"
+    xmlns:ogc="http://www.opengis.net/ogc"
+    xmlns:ows="http://www.opengis.net/ows"
+    xmlns:csw="http://www.opengis.net/cat/csw"
+    xmlns:gml="http://www.opengis.net/gml"
+    xmlns:rim="urn:oasis:names:tc:ebxml-regrep:rim:xsd:2.5"
+    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
+    xmlns:wfs="http://www.opengis.net/wfs" 
+    xmlns:sld="http://www.opengis.net/sld"
+    xmlns:owscat="http://www.ec.gc.ca/owscat"
+    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
+    xmlns:xlink="http://www.w3.org/1999/xlink">
+
+  <xsl:output method="xml" encoding="utf-8" omit-xml-declaration="yes"/>
+  <xsl:strip-space elements="*"/>
+
+  <!-- The coordinates of the DHTML Layer on the HTML page -->
+  <xsl:param name="modelId"/>
+  <xsl:param name="widgetId"/>
+  <xsl:param name="id"></xsl:param>
+  
+  <!-- Match Root -->
+  <xsl:template match="/">
+    <wmc:OWSContext>
+		  <wmc:General>
+		    <wmc:Window width="600" height="300"/>
+		    <ows:BoundingBox crs="EPSG:4326">
+		      <ows:LowerCorner>-180 -90</ows:LowerCorner>
+		      <ows:UpperCorner>180 90</ows:UpperCorner>
+		    </ows:BoundingBox>
+		    <wmc:Title xml:lang="en">Mapbuilder Generated Context</wmc:Title>
+		  </wmc:General>
+      <wmc:ResourceList>
+        <xsl:apply-templates/>
+      </wmc:ResourceList>
+    </wmc:OWSContext>
+  </xsl:template>
+
+  <!-- Match Layer (ExtrinsicObject -->
+  <xsl:template match="rim:ExtrinsicObject">
+
+    <!-- When layer is WFS: FeatureType -->
+    <!-- When layer is WMS: Layer       -->
+    <!-- else (fallback)  : Layer       -->
+    <xsl:variable name="element_name">
+      <xsl:variable name="pos" select="position()"/>
+      <xsl:variable name="servicetype" select="../rim:Service[(($pos+1) div 2)]/rim:Slot[@name='Service Type']/rim:ValueList/rim:Value"/>
+      <xsl:choose>
+        <xsl:when test="($servicetype = 'WFS') or ($servicetype = 'OGC:WFS')">FeatureType</xsl:when>
+        <xsl:when test="($servicetype = 'WMS') or ($servicetype = 'OGC:WMS')">Layer</xsl:when>
+        <xsl:otherwise>Layer</xsl:otherwise>
+      </xsl:choose>
+    </xsl:variable>
+
+    <xsl:variable name="queryable" select="./rim:Slot[@name='Queryable']/rim:ValueList/rim:Value/text()"/>
+
+    <!-- If a layer is a 'Theme', then don't return anything, since it is'nt a queryable layer.
+         A theme is a meta layer for grouping (WMS) layers
+    -->
+    <xsl:if test="@objectType != 'Theme'">
+      <xsl:element name="wmc:{$element_name}">
+          <xsl:attribute name="queryable">1</xsl:attribute>
+          <xsl:attribute name="hidden">0</xsl:attribute>
+          <xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
+          <!-- insert service -->
+          <!--xsl:apply-templates select="//rim:Service[position()=(position()+1)]"/-->
+          <xsl:call-template name="Service">
+            <xsl:with-param name="pos" select="position()"/>
+          </xsl:call-template>
+          <wmc:Name>
+            <xsl:value-of select="rim:Name/rim:LocalizedString/@value"/>
+          </wmc:Name>
+          <wmc:Title>
+            <xsl:value-of select="rim:Slot[@name='Title']//rim:Value"/>
+          </wmc:Title>
+          <wmc:Abstract>
+            <xsl:value-of select="rim:Description/rim:LocalizedString/@value"/>
+          </wmc:Abstract>
+      </xsl:element>
+    </xsl:if>
+  </xsl:template>
+
+  <!-- Match Service -->
+  <!-- xsl:template match="rim:Service[position()={$pos}]"-->
+  <xsl:template name="Service">
+    <xsl:param name="pos"/>
+  
+    <xsl:for-each select="../rim:Service[(($pos+1) div 2)]">
+	    <wmc:Server>
+	      <xsl:attribute name="id">
+	        <xsl:value-of select="@id"/>
+	      </xsl:attribute>
+	      <xsl:attribute name="service">
+	        <xsl:value-of select="rim:Slot[@name='Service Type']//rim:Value"/>
+	      </xsl:attribute>
+	      <xsl:attribute name="version">
+	        <xsl:value-of select="@userVersion"/>
+	      </xsl:attribute>
+	      <xsl:attribute name="title">
+	        <xsl:value-of select="rim:Slot[@name='Title']//rim:Value"/>
+	      </xsl:attribute>
+	      <!-- TBD: How do we extract method=POST/GET? -->
+	      <wmc:OnlineResource method="POST" xlink:type="simple">
+	        <xsl:attribute name="xlink:href">
+	          <xsl:value-of select=".//@accessURI"/><!-- works for cubewerx -->
+	        </xsl:attribute>
+	      </wmc:OnlineResource>
+	    </wmc:Server>
+    </xsl:for-each>
+
+  </xsl:template>
+  
+  <xsl:template match="text()|@*"/>
+  
+</xsl:stylesheet>
Index: lib/spatial/mapbuilder/examples/shipTracks/stylesheets/AoiForm.xsl
===================================================================
--- lib/spatial/mapbuilder/examples/shipTracks/stylesheets/AoiForm.xsl	(nonexistent)
+++ lib/spatial/mapbuilder/examples/shipTracks/stylesheets/AoiForm.xsl	(revision 4307)
@@ -0,0 +1,70 @@
+<?xml version="1.0" encoding="utf-8" standalone="no" ?>
+<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
+
+<!--
+Description: Output a form for display of the context doc AOI
+Author:      Mike Adair
+Licence:     LGPL as per: http://www.gnu.org/copyleft/lesser.html
+
+AoiForm.xsl,v 1.2 2004/06/25 17:59:38 madair1 Exp
+-->
+
+  <xsl:output method="xml" encoding="utf-8" omit-xml-declaration="yes"/>
+
+  <!-- The common params set for all widgets -->
+  <xsl:param name="modelId"/>
+  <xsl:param name="widgetId"/>
+
+  <!-- The name of the form for coordinate output -->
+  <xsl:param name="formName">AOIForm</xsl:param>
+
+  <!-- Text params for this widget -->
+  <xsl:param name="title"/>
+  <xsl:param name="north"/>
+  <xsl:param name="south"/>
+  <xsl:param name="east"/>
+  <xsl:param name="west"/>
+  
+  <!-- Main html -->
+  <xsl:template match="/">
+    <div>
+    <form name="{$formName}" id="{$formName}">
+      <table>
+        <tr>
+          <th align="left" colspan="3">
+          </th>
+        </tr>
+        <tr>
+          <td>
+          </td>
+          <td>
+            <input name="northCoord" type="hidden" size="10" style="font: 8pt Verdana, geneva, arial, sans-serif;" readonly="readonly"/>
+          </td>
+          <td>
+          </td>
+        </tr>
+        <tr>
+          <td>
+            <input name="westCoord" type="hidden" size="10" style="font: 8pt Verdana, geneva, arial, sans-serif;" readonly="readonly"/>
+          </td>
+          <td>
+          </td>
+          <td>
+            <input name="eastCoord" type="hidden" size="10" style="font: 8pt Verdana, geneva, arial, sans-serif;" readonly="readonly"/>
+          </td>
+        </tr>
+        <tr>
+          <td>
+          </td>
+          <td>
+            <input name="southCoord" type="hidden" size="10" style="font: 8pt Verdana, geneva, arial, sans-serif;" readonly="readonly"/>
+          </td>
+          <td>
+          </td>
+        </tr>
+      </table>
+    </form>
+    </div>
+  </xsl:template>
+  
+</xsl:stylesheet>
Index: lib/spatial/mapbuilder/examples/shipTracks/stylesheets/georss2wfs.xsl
===================================================================
--- lib/spatial/mapbuilder/examples/shipTracks/stylesheets/georss2wfs.xsl	(nonexistent)
+++ lib/spatial/mapbuilder/examples/shipTracks/stylesheets/georss2wfs.xsl	(revision 4307)
@@ -0,0 +1,46 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:gml3="http://www.opengis.net/gml/3.1.1" xmlns:gml="http://www.opengis.net/gml" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns:rss="http://purl.org/rss/1.0/" xmlns:taxo="http://purl.org/rss/1.0/modules/taxonomy/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:syn="http://purl.org/rss/1.0/modules/syndication/" xmlns:georss="http://www.georss.org/georss"  xmlns:wfs="http://www.opengis.net/wfs" xmlns:mb="http://mapbuilder.sourceforge.net/mapbuilder"> 
+<!--
+Description: A stylesheet to convert strange geobliki wfs to standards-compliant wfs.
+Author:      Andreas Hocevar andreas.hocevarATgmail.com
+Licence:     LGPL as per: http://www.gnu.org/copyleft/lesser.html
+
+$Id: georss2wfs.xsl 3926 2008-03-20 14:13:35Z steven $
+-->
+  <xsl:template match="rdf:RDF">
+    <wfs:FeatureCollection>
+      <xsl:for-each select="rss:item">
+        <xsl:call-template name="featureMember"/>
+      </xsl:for-each>
+    </wfs:FeatureCollection>
+  </xsl:template>
+
+  <xsl:template name="featureMember">
+    <gml:featureMember>
+    	<mb:geoRssFeature>
+    	  <xsl:attribute name="fid"><xsl:value-of select="./@id"/></xsl:attribute>
+    	  <mb:geom>
+    	    <xsl:call-template name="point"/>
+    	    <xsl:call-template name="lineString"/>
+    	  </mb:geom>
+    	</mb:geoRssFeature>      
+    </gml:featureMember>
+  </xsl:template>
+
+<xsl:template name="point">
+  <xsl:if test="georss:where/gml3:Point">
+    <gml:Point>
+      <gml:pos><xsl:value-of select="georss:where/gml3:Point/gml3:pos"/></gml:pos>
+    </gml:Point>
+  </xsl:if>
+</xsl:template>
+
+<xsl:template name="lineString">
+  <xsl:if test="georss:where/gml3:LineString">
+    <gml:LineString>
+      <gml:posList dimension="2"><xsl:value-of select="translate(georss:where/gml3:LineString/gml3:posList, ',', ' ')"/></gml:posList>
+    </gml:LineString>
+  </xsl:if>
+</xsl:template>
+
+</xsl:stylesheet>
Index: lib/spatial/mapbuilder/examples/shipTracks/stylesheets/Legend.xsl
===================================================================
--- lib/spatial/mapbuilder/examples/shipTracks/stylesheets/Legend.xsl	(nonexistent)
+++ lib/spatial/mapbuilder/examples/shipTracks/stylesheets/Legend.xsl	(revision 4307)
@@ -0,0 +1,175 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<xsl:stylesheet 
+    xmlns:wmc="http://www.opengis.net/context" 
+    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
+    xmlns:gml='http://www.opengis.net/gml' 
+    xmlns:wfs='http://www.opengis.net/wfs'
+    xmlns:xlink='http://www.w3.org/1999/xlink'
+    version="1.0">
+<!--
+Description: Convert a Web Map Context into a HTML Legend
+Author:      Cameron Shorter cameron ATshorter.net
+Licence:     LGPL as per: http://www.gnu.org/copyleft/lesser.html
+
+$Id: Legend.xsl 3926 2008-03-20 14:13:35Z steven $
+$Name$
+-->
+  <xsl:output method="xml" encoding="utf-8" omit-xml-declaration="yes"/>
+  
+  <!-- The common params set for all widgets -->
+  <xsl:param name="lang">en</xsl:param>
+  <xsl:param name="modelId"/>
+  <xsl:param name="widgetId"/>
+
+  <xsl:param name="skinDir"/>
+  
+  <!-- Text params for this widget -->
+  <xsl:param name="title"/>
+  
+<!-- The name of the javascript context object to call -->
+  <xsl:param name="featureName"/>
+  <xsl:param name="hidden"/>
+  <xsl:param name="context">config.objects.<xsl:value-of select="$modelId"/></xsl:param>
+
+<!-- Main html -->
+  
+  <xsl:template match="/wmc:OWSContext">
+    <table border="0" cellpadding="1" cellspacing="0">
+    
+      <xsl:apply-templates select="wmc:ResourceList/wmc:Layer">
+        <xsl:sort select="position()" order="descending" data-type="number"/>
+      </xsl:apply-templates>
+      
+     <xsl:apply-templates select="wmc:ResourceList/wmc:RssLayer">
+        <xsl:sort select="position()" order="descending" data-type="number"/>
+      </xsl:apply-templates>
+    </table>
+  </xsl:template>
+  
+  <xsl:template match="/wfs:FeatureCollection">
+    <table border="0" cellpadding="1" cellspacing="0">
+      <tr>
+        <th colspan="3">WFS Features</th>
+      </tr>
+      <tr>
+  <!-- Visiblity -->
+        <td>
+          <xsl:if test="$hidden='false'">
+            <input type="checkbox" checked="true" id="legend_{$featureName}" onclick="{$context}.setHidden('{$featureName}',!document.getElementById('legend_{$featureName}').checked)"/>
+          </xsl:if>
+          <xsl:if test="$hidden='true'">
+            <input type="checkbox" id="legend_{$featureName}" onclick="{$context}.setHidden('{$featureName}',! document.getElementById('legend_{$featureName}').checked)"/>
+          </xsl:if>
+        </td>
+  <!-- No query capability yet -->
+        <td>
+        </td>
+        <td>
+          <xsl:value-of select="$featureName"/>
+        </td>
+      </tr>
+    </table>
+  </xsl:template>
+  
+<!-- Layer -->
+  <xsl:template match="wmc:Layer">
+    <tr>
+  <!-- Visiblity -->
+      <td>
+        <xsl:if test="@hidden='0'">
+          <input type="checkbox" checked="true" id="legend_{wmc:Name}" onclick="{$context}.setHidden('{wmc:Name}',!document.getElementById('legend_{wmc:Name}').checked)"/>
+        </xsl:if>
+        <xsl:if test="@hidden='1'">
+          <input type="checkbox" id="legend_{wmc:Name}" onclick="{$context}.setHidden('{wmc:Name}',! document.getElementById('legend_{wmc:Name}').checked)"/>
+        </xsl:if>
+      </td>
+  <!-- Query Image -->
+      <td>
+        <xsl:if test="@queryable='1'">
+          <img
+            id="query_{wmc:Name}"
+            title="Click to set {wmc:Title} as the query layer"
+            onclick="config.objects.{$widgetId}.selectLayer(config.objects.{$widgetId},'{wmc:Name}')"
+            src="{$skinDir}/images/id.gif" />
+        </xsl:if>
+      </td>
+  <!-- Title -->
+      <td>
+        <xsl:choose>
+          <xsl:when test="wmc:Title/@xml:lang">              
+            <xsl:value-of select="wmc:Title[@xml:lang=$lang]"/>
+          </xsl:when>
+          <xsl:otherwise>
+            <xsl:value-of select="wmc:Title"/>
+          </xsl:otherwise>
+        </xsl:choose>
+      </td>
+    </tr>
+  <!-- StyleList -->
+    <tr>
+      <td></td>
+      <td></td>
+      <td>
+      <xsl:if test="wmc:StyleList/wmc:Style[@current='1']/wmc:LegendURL"> 
+          <xsl:element name="IMG">
+              <xsl:attribute name="SRC">
+                <xsl:value-of select="wmc:StyleList/wmc:Style[@current='1']/wmc:LegendURL/wmc:OnlineResource/@xlink:href"/> 
+              </xsl:attribute>
+          </xsl:element>
+         </xsl:if>
+      </td>
+    </tr>
+  </xsl:template>
+  
+   <xsl:template match="wmc:RssLayer">
+    <tr>
+  <!-- Visiblity -->
+      <td>
+        <xsl:if test="@hidden='0'">
+          <input type="checkbox" checked="true" id="legend_{wmc:Title}" onclick="{$context}.setHidden('{@id}',!document.getElementById('legend_{wmc:Title}').checked)"/>
+        </xsl:if>
+        <xsl:if test="@hidden='1'">
+          <input type="checkbox" id="legend_{wmc:Title}" onclick="{$context}.setHidden('{@id}',! document.getElementById('legend_{wmc:Title}').checked)"/>
+        </xsl:if>
+      </td>
+  <!-- Query Image -->
+      <td>
+        <xsl:if test="@queryable='1'">
+          <img
+            id="query_{wmc:Name}"
+            title="Click to set {wmc:Title} as the query layer"
+            onclick="config.objects.{$widgetId}.selectLayer(config.objects.{$widgetId},'{wmc:Name}')"
+            src="{$skinDir}/images/id.gif" />
+        </xsl:if>
+      </td>
+  <!-- Title -->
+      <td>
+        <xsl:choose>
+          <xsl:when test="wmc:Title/@xml:lang">              
+            <xsl:value-of select="wmc:Title[@xml:lang=$lang]"/>
+          </xsl:when>
+          <xsl:otherwise>
+            <xsl:value-of select="wmc:Title"/>
+          </xsl:otherwise>
+        </xsl:choose>
+      </td>
+    </tr>
+  <!-- StyleList -->
+    <tr>
+      <td></td>
+      <td></td>
+      <td>
+      <xsl:if test="wmc:StyleList/wmc:Style[@current='1']/wmc:LegendURL"> 
+          <xsl:element name="IMG">
+              <xsl:attribute name="SRC">
+                <xsl:value-of select="wmc:StyleList/wmc:Style[@current='1']/wmc:LegendURL/wmc:OnlineResource/@xlink:href"/> 
+              </xsl:attribute>
+          </xsl:element>
+         </xsl:if>
+      </td>
+    </tr>
+  </xsl:template>
+  
+  <xsl:template match="text()|@*"/>
+  
+</xsl:stylesheet>
Index: lib/spatial/mapbuilder/examples/shipTracks/stylesheets/GeoRSSListing.xsl
===================================================================
--- lib/spatial/mapbuilder/examples/shipTracks/stylesheets/GeoRSSListing.xsl	(nonexistent)
+++ lib/spatial/mapbuilder/examples/shipTracks/stylesheets/GeoRSSListing.xsl	(revision 4307)
@@ -0,0 +1,54 @@
+<?xml version="1.0" encoding="UTF-8"?>
+
+<!--
+Description: presents the list of events in a GeoRSS
+Author:      adair
+Licence:     LGPL as specified in http://www.gnu.org/copyleft/lesser.html .
+
+$Id: GeoRSSListing.xsl 3926 2008-03-20 14:13:35Z steven $
+$Name:  $
+-->
+
+<xsl:stylesheet version="1.0" 
+  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
+  xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" 
+  xmlns:rss="http://purl.org/rss/1.0/" 
+  xmlns:taxo="http://purl.org/rss/1.0/modules/taxonomy/" 
+  xmlns:dc="http://purl.org/dc/elements/1.1/" 
+  xmlns:syn="http://purl.org/rss/1.0/modules/syndication/" 
+  xmlns:geo="http://www.w3.org/2003/01/geo/wgs84_pos#">
+
+  <xsl:output method="xml" omit-xml-declaration="yes" encoding="utf-8" indent="yes"/>
+
+  <!-- The coordinates of the DHTML Layer on the HTML page -->
+  <xsl:param name="modelId"/>
+  <xsl:param name="targetModelId"/>
+  <xsl:param name="widgetId"/>
+  <xsl:param name="hiddenItems"/>
+  
+  <!-- template rule matching source root element -->
+  <xsl:template match="/rdf:RDF ">
+    <table>
+      <xsl:apply-templates select="rss:item"/>
+    </table>
+  </xsl:template>
+
+  <xsl:template match="rss:item">
+    <xsl:variable name="fid"><xsl:value-of select="@id"/></xsl:variable>
+    <xsl:variable name="x"><xsl:value-of select="geo:long"/></xsl:variable>
+    <xsl:variable name="y"><xsl:value-of select="geo:lat"/></xsl:variable>
+    <xsl:variable name="link"><xsl:value-of select="rss:link"/></xsl:variable>
+    <xsl:variable name="icon">../../lib/skin/default<xsl:value-of select="geo:icon"/></xsl:variable>
+    <tr>
+      <td>
+        <input type="checkbox" checked="true" onclick="this.checked?config.objects.{$modelId}.setParam('showFeature','{$fid}'):config.objects.{$modelId}.setParam('hideFeature','{$fid}')" />
+      </td>
+      <td onmouseover="config.objects.{$modelId}.setParam('highlightFeature','{$fid}')" onmouseout="config.objects.{$modelId}.setParam('dehighlightFeature','{$fid}')">
+        <!-- img src="{$icon}" / -->
+        <a href="{$link}"><xsl:value-of select="rss:title"/></a>
+        <xsl:copy-of select="rss:description"/>
+      </td>
+    </tr>
+  </xsl:template>
+
+</xsl:stylesheet>
Index: lib/spatial/mapbuilder/examples/shipTracks/stylesheets/CollectionList.xsl
===================================================================
--- lib/spatial/mapbuilder/examples/shipTracks/stylesheets/CollectionList.xsl	(nonexistent)
+++ lib/spatial/mapbuilder/examples/shipTracks/stylesheets/CollectionList.xsl	(revision 4307)
@@ -0,0 +1,47 @@
+<?xml version="1.0" encoding="ISO-8859-1"?>
+
+<!--
+Description: parses an OGC context collection document to generate a context pick list
+Author:      adair
+Licence:     LGPL as specified in http://www.gnu.org/copyleft/lesser.html .
+
+$Id: CollectionList.xsl 3926 2008-03-20 14:13:35Z steven $
+$Name:  $
+-->
+
+<xsl:stylesheet version="1.0" 
+    xmlns:wmc="http://www.opengis.net/context" 
+    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
+    xmlns:xlink="http://www.w3.org/1999/xlink"
+    exclude-result-prefixes="wmc xlink">
+
+  <xsl:output method="xml" omit-xml-declaration="yes" encoding="utf-8"/>
+  <xsl:strip-space elements="*"/>
+
+  <!-- The common params set for all widgets -->
+  <xsl:param name="lang">en</xsl:param>
+
+  <!-- Text params for this widget -->
+  <xsl:param name="title"/>
+
+  <!-- The coordinates of the DHTML Layer on the HTML page -->
+  <!-- xsl:param name="jsfunction">config.loadModel('</xsl:param -->
+  <xsl:param name="widgetId"/>
+  <xsl:param name="targetModel"/>
+
+  <!-- template rule matching source root element -->
+  <xsl:template match="/wmc:ViewContextCollection">
+
+    <ul>
+      <xsl:apply-templates select="wmc:ViewContextReference"/>
+    </ul>
+
+  </xsl:template>
+
+  <xsl:template match="wmc:ViewContextReference">
+    <xsl:param name="linkUrl">config.objects.<xsl:value-of select="$widgetId"/>.switchMap(config.objects.<xsl:value-of select="$widgetId"/>,'<xsl:value-of select="wmc:ContextURL/wmc:OnlineResource/@xlink:href"/>')</xsl:param>
+    <xsl:param name="name"><xsl:value-of select='wmc:Title'/></xsl:param>
+    <input type='button' value="{$name}"  onClick="{$linkUrl}" />
+  </xsl:template>
+  
+</xsl:stylesheet>
Index: lib/spatial/mapbuilder/examples/catalog/LayerMetadata.js
===================================================================
--- lib/spatial/mapbuilder/examples/catalog/LayerMetadata.js	(nonexistent)
+++ lib/spatial/mapbuilder/examples/catalog/LayerMetadata.js	(revision 4307)
@@ -0,0 +1,63 @@
+/*
+License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
+$Id: Abstract.js 2546 2007-01-23 12:07:39Z gjvoosten $
+*/
+
+// Ensure this object's dependencies are loaded.
+mapbuilder.loadScript(baseDir+"/widget/WidgetBaseXSL.js");
+
+/**
+ * Show a layer's metadata
+ * @constructor
+ * @base WidgetBaseXSL
+ * @param widgetNode  The widget's XML object node from the configuration document.
+ * @param model       The model object that this widget belongs to.
+ */
+
+
+function LayerMetadata(widgetNode, model) {
+  WidgetBaseXSL.apply(this,new Array(widgetNode, model));
+
+  this.model.setParam("layerMetadata", true);
+  /**
+   * Toggles the visibility of a layer's metadata
+   * @param layerNode Dom element containing the OWS layer 
+   * @param domNode Pointer the Dom element where the metadata should
+   *                           be shown
+   */
+  this.paint = function(objRef, params) {
+
+    var layerNode = objRef.model.getLayer(params.layerId);
+    var domNode = document.getElementById(params.domNodeId);
+
+    if (!domNode || !layerNode) {
+      return;
+    }
+
+    // If clicked and metadata was visible, hide it and do nothing
+    if (domNode.style.display && (domNode.style.display != "none") && (domNode.innerHTML != "")) { 
+      domNode.style.display = "none";
+      return false;
+    }
+
+    // add the layerNode as a parameter to the XSL
+    objRef.stylesheet.setParameter("layerNode", layerNode);
+
+    // create meta HTML
+    var metadataHtml = objRef.stylesheet.transformNodeToString(objRef.model.doc);
+
+    // insert the metadata HTML in the designated Dom Element 
+    domNode.innerHTML = metadataHtml;
+
+    // make it visible 
+    domNode.style.display = "block";
+
+    // debug info. TBD: remove
+    //console.info((new XMLSerializer()).serializeToString(layerNode));
+
+  }
+  this.model.addListener("layerMetadata", this.paint, this);
+
+}
+
+
Index: lib/spatial/mapbuilder/examples/catalog/CatalogSearchForm.js
===================================================================
--- lib/spatial/mapbuilder/examples/catalog/CatalogSearchForm.js	(nonexistent)
+++ lib/spatial/mapbuilder/examples/catalog/CatalogSearchForm.js	(revision 4307)
@@ -0,0 +1,206 @@
+/*
+License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
+$Id: $
+*/
+
+// Ensure this object's dependencies are loaded.
+mapbuilder.loadScript(baseDir+"/widget/WidgetBaseXSL.js");
+
+// For customised searching/loading indication
+httpStatusMsg = ['uninitialized','searching','loaded','building results list','completed'];
+
+/**
+ * Display a Catalog Search form.
+ * @constructor
+ * @base WidgetBaseXSL
+ * @param widgetNode  The widget's XML object node from the configuration document.
+ * @param model       The model object that this widget belongs to.
+ */
+function CatalogSearchForm(widgetNode, model) {
+  WidgetBaseXSL.apply(this,new Array(widgetNode, model));
+
+  this.targetContext         = this.getProperty("mb:targetContext");
+  this.wrsUrl                = this.getProperty("mb:wrsUrl");
+  this.wrsServiceAssociation = this.getProperty("mb:wrsServiceAssociation");
+  this.convert2ContextXsl    = this.getProperty("mb:convert2ContextXsl");
+  this.queryXsl              = this.getProperty("mb:queryXsl");
+
+  this.httpPayload = new Object();
+  this.httpPayload.url = this.wrsUrl;
+  this.httpPayload.method = "post";
+  
+  this.mapModel = this.getProperty("mb:mapModel") || model.id;
+
+  /**
+   * Refreshes the form onblur handlers when this widget is painted.
+   * @param objRef Pointer to this CurorTrack object.
+   */
+  this.postPaint = function() {
+    //config.objects[this.mapModel].addListener('aoi', this.displayAoiCoords, this);
+
+    this.searchForm = document.getElementById(this.formName);
+    this.searchForm.parentWidget = this;
+    //this.searchForm.westCoord.model = this.model;
+    //this.searchForm.northCoord.model = this.model;
+    //this.searchForm.eastCoord.model = this.model;
+    //this.searchForm.southCoord.model = this.model;
+    this.searchForm.onkeypress = this.handleKeyPress;
+
+  }
+
+  /**
+   * Output the AOI coordinates to the associated form input elements.  This
+   * method is registered as an AOI listener on the context doc.
+   * @param objRef Pointer to this searchForm object.
+   */
+  //CatalogSearchForm.prototype.displayAoiCoords = function(objRef) {
+    //var aoi = config.objects[objRef.mapModel].getParam("aoi");
+    //objRef.searchForm.westCoord.value = aoi[0][0];
+    //objRef.searchForm.northCoord.value = aoi[0][1];
+    //objRef.searchForm.eastCoord.value = aoi[1][0];
+    //objRef.searchForm.southCoord.value = aoi[1][1];
+
+  //}
+
+  /**
+   * Handles user input from the form element.  This is an onblur handler for 
+   * the input elements.
+   */
+  CatalogSearchForm.prototype.setAoi = function() {
+//    var aoi = config.objects[this.mapModel].getParam("aoi");
+//    if (aoi) {
+//      var ul = aoi[0];
+//      var lr = aoi[1];
+//      switch(this.name) {
+//        case 'westCoord':
+//          ul[0] = this.value;
+//          break;
+//        case 'northCoord':
+//          ul[1] = this.value;
+//          break;
+//        case 'eastCoord':
+//          lr[0] = this.value;
+//          break;
+//        case 'southCoord':
+//          lr[1] = this.value;
+//          break;
+//      }
+//      config.objects[this.mapModel].setParam("aoi",new Array(ul,lr) );
+//    }
+  }
+
+/**
+ * Change the AOI coordinates from select box choice of prefined locations
+ * @param bbox the bbox value of the location keyword chosen
+ */
+  CatalogSearchForm.prototype.setLocation = function(bbox) {
+    var bboxArray = new Array();
+    bboxArray     = bbox.split(",");
+    var ul = new Array(parseFloat(bboxArray[0]),parseFloat(bboxArray[2]));
+    var lr = new Array(parseFloat(bboxArray[1]),parseFloat(bboxArray[3]));
+    config.objects[this.mapModel].setParam("aoi",new Array(ul,lr));
+
+  }
+
+
+  /**
+   * Build and send a catalog query. The results will be inserted into the
+   * targetModel which will trigger an event to handleResponse().
+   * 
+   * @return none 
+   */
+  CatalogSearchForm.prototype.doSelect = function() {
+    // Register for an event sent after the catalog query has finished
+
+    if(!this.initialized){
+      this.targetModel.addListener("loadModel",this.handleResponse,this);
+      this.xslProcessor = new XslProcessor(this.convert2ContextXsl);
+      this.initialized=1;
+    }
+    
+    // call buildQuery method to read form values, put them into the model
+    // and perform an XSL translation to get the WRS Query
+    var wrsQueryXML = this.buildQuery();
+    
+    // POST the query to the WRS Service configured in config.xml (wrsUrl)
+    this.httpPayload.postData= wrsQueryXML;
+    this.targetModel.transactionType="insert";
+    this.targetModel.newRequest(this.targetModel,this.httpPayload);
+    
+    // Load the new model
+    // Disabled, otherwise the loading indicator doesn't work
+    //this.targetModel.callListeners("loadModel");
+    
+    // Activate the loading indicator
+    this.targetModel.callListeners("refresh");
+
+  }
+
+  /**
+   * Builds WRS Catalog query 
+   * returns: WRS Query XML (string)
+   * 
+   * @return wrsQueryXML A textual representation of the WRS Query XML
+   */
+  CatalogSearchForm.prototype.buildQuery = function() {
+    // Get the reference to the form
+    this.searchForm = document.getElementById(this.formName);
+         
+    // Fill the model with the values needed for building the query
+    // TBD: This is not a correct way to address the model, since the form values will disappear when
+    //      the model changes. View needs to correspond to the model.
+
+    // added empty string '' to prevent IE from crashing on empty/null values
+    this.model.setXpathValue(this.model, "/filter/keywords", this.searchForm.keywords.value + '', false);
+    this.model.setXpathValue(this.model, "/filter/servicetype", this.searchForm.serviceType.value + '', false);
+    this.model.setXpathValue(this.model, "/filter/serviceassociation", this.wrsServiceAssociation + '', false);
+
+	  // determine the BBox
+    var aoi = config.objects[this.mapModel].getParam("aoi");
+    var bboxStr = "";
+    if (aoi) {
+      // a bbox was set in the map pane
+      bboxStr = aoi[0][0]+","+aoi[1][1]+" "+aoi[1][0]+","+aoi[0][1];
+    } else {
+      // no bbox was set, use the bbox of the map model
+      var bbox = config.objects[this.mapModel].getBoundingBox();
+      bboxStr = bbox[0]+","+bbox[1]+" "+bbox[2]+","+bbox[3];
+    }
+
+    // Add location based filter (BBOX)
+    // TBD: uncomment this line below when WRS filtering works OK
+    //this.model.setXpathValue(this.model, "/filter/location", bboxStr, false);
+
+    // Load the XSL to generate the WRS Query
+    //this.wrsQuery=new XslProcessor(baseDir+"/tool/xsl/wrs_Query.xsl");
+    var queryProcessor = new XslProcessor(this.queryXsl);
+    
+    // Add filter to XSL as a parameter
+    queryProcessor.setParameter("filter", this.model.doc);
+
+    // Do the actual XSL translation to generate the WRS Query
+    var wrsQueryXML = queryProcessor.transformNodeToString(this.model.doc);
+    return wrsQueryXML;
+
+  }
+
+  /**
+   * Convert the response of a Catalog Query into an OWSContext document
+   * so that it can be processed.
+   * Called after the response from a Catalog query has been received and 
+   * populated in the targetModel.
+   * @param objRef Pointer to widget object.
+   */
+  CatalogSearchForm.prototype.handleResponse = function(objRef) {
+
+    var newContext=objRef.xslProcessor.transformNodeToObject(objRef.targetModel.doc);
+
+    window.config.objects[objRef.targetContext].setModel(
+      window.config.objects[objRef.targetContext],
+      newContext);
+  }
+
+  //set some properties for the form output
+  this.formName = "WebServiceForm_" + mbIds.getId();
+  this.stylesheet.setParameter("formName", this.formName);
+}
